﻿using System;
using System.Collections;

using DevExpress.XtraEditors;
using DevExpress.XtraTreeList.Columns;
using DevExpress.XtraTreeList.Nodes;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Load += Form_Load;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            this.treeList.RowHeight                              = 25;
            this.treeList.OptionsView.AutoWidth                  = false;
            this.treeList.OptionsBehavior.ReadOnly               = true;
            this.treeList.OptionsBehavior.PopulateServiceColumns = true;
            this.treeList.KeyFieldName                           = "ID";
            this.treeList.ParentFieldName                        = "RegionID";

            this.treeList.DataSource = SalesData.GetSalesDataList();

            this.treeList.Columns[this.treeList.KeyFieldName   ].Visible = false;
            this.treeList.Columns[this.treeList.ParentFieldName].Visible = false;

            IEnumerator enumerator = this.treeList.Nodes.GetEnumerator();

            TreeListColumn regionColumn = this.treeList.Columns["Region"];
            TreeListColumn salesColumn  = this.treeList.Columns["Sales" ];

            while(enumerator.MoveNext())
            {
                TreeListNode childNode = (TreeListNode)enumerator.Current;

                string displayText = childNode.GetDisplayText(regionColumn);

                if(displayText == "North America")
                {
                    decimal newSales = (decimal)childNode.GetValue(salesColumn) / 2;

                    childNode.SetValue(salesColumn, newSales);
                }
            }

            this.treeList.BestFitColumns();

            this.treeList.ExpandAll();
        }

        #endregion
    }
}